#
# spec file for package dhcpcd (Version 3.2.3)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash binutils brp-check-internal bzip2 coreutils cpio cpp cpp43 cracklib cvs diffutils file filesystem fillup findutils gawk gcc gcc43 gdbm gettext-runtime gettext-tools glibc glibc-devel glibc-locale gmp grep groff gzip info insserv less libacl libattr libbz2-1 libbz2-devel libdb-4_5 libgcc43 libgomp43 libltdl-3 libmpfr1 libmudflap43 libncurses5 libreadline5 libstdc++43 libtool libuuid1 libvolume_id libxcrypt libzio linux-kernel-headers login m4 make man net-tools netcfg pam pam-modules patch perl perl-base permissions popt psmisc rpm sed sysvinit tar terminfo-base texinfo timezone util-linux zlib


Name:           dhcpcd
Version:        3.2.3
Release:        5
Summary:        A DHCP Client Daemon
Url:            http://developer.berlios.de/projects/dhcpcd/
#Source: 	http://prdownload.berlios.de/dhcpcd/dhcpcd-3.2.3.tar.bz2
Source:         dhcpcd-%{version}.tar.bz2
Source1:        dhcpcd-1-vs-3
Source2:        dhcpcd-test
Patch1:         dhcpcd-%{version}-suse.diff 
Patch2:         dhcpcd-%{version}-more-params.diff 
Patch3:         dhcpcd-%{version}-ntp-runtime-servers.diff 
Patch4:         dhcpcd-%{version}-set-route.diff
Patch5:         dhcpcd-%{version}-clientid.diff
License:        GPL v2 or later
Group:          Productivity/Networking/Boot/Clients
Provides:       dhcp_client
Requires:       net-tools
AutoReqProv:    on
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
dhcpcd gets an IP address and other information from a corresponding
DHCP server, configures the network interface automatically, and tries
to renew the lease time depending on the command line option.



Authors:
--------
    Roy Salisbury Marples <roy@marples.name>

%debug_package
%prep
%setup  -n dhcpcd-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
cp %{S:1} .

%build
make CFLAGS="$RPM_OPT_FLAGS -O2 -pipe -fpie -DENABLE_SYSV=1 -UENABLE_DUID" LDFLAGS="-pie"

%install
make install DESTDIR="$RPM_BUILD_ROOT"
install -D %{S:2} $RPM_BUILD_ROOT/usr/sbin/dhcpcd-test

%post
#remove dhcpcd 1 parameters which are not implemented in dhcpcd 3.2.3
perl -i -pe 's/^(DHCLIENT_ADDITIONAL_OPTIONS=.*)-B(.*)/$1$2/' /etc/sysconfig/network/dhcp
perl -i -pe 's/^(DHCLIENT_ADDITIONAL_OPTIONS=.*)-S(.*)/$1$2/' /etc/sysconfig/network/dhcp
perl -i -pe 's/^(DHCLIENT_ADDITIONAL_OPTIONS=.*)-z \d+(.*)/$1$2/' /etc/sysconfig/network/dhcp
perl -i -pe 's/^(DHCLIENT_ADDITIONAL_OPTIONS=.*)-w \d+(.*)/$1$2/' /etc/sysconfig/network/dhcp

%postun
%{insserv_cleanup}

%files
%defattr(-,root,root)
%doc README dhcpcd-1-vs-3
%doc %{_mandir}/man8/dhcpcd.8*
/sbin/dhcpcd
/usr/sbin/dhcpcd-test

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Wed Jun 04 2008 varkoly@suse.de
- (bnc#396165) - dhcpcd does not correctly use MAC address of network interface for ClientID
- (bnc#389759) DHCP fails after update to Factory
  The %%post script removes the not implemented attributes from
  DHCLIENT_ADDITIONAL_OPTIONS in /etc/sysconfig/network/dhcp
* Wed May 14 2008 varkoly@suse.de
- update to 3.2.3
- Fix hostname lookup
- Always open UDP port for DHCP client to avoid more ICMP nastyness.
- Be more RFC conformant regarding sending server id.
- Add a listening port for linux for when we have configured an address and need to renew.
- Add -S to optionally request a Microsoft CSR. -SS only request a Microsoft CSR and not a normal.
- Fix poll timeout.
- Just warn when running as non root.
- Allow hardware type to be specified in the ClientID.
- Some of code changes:
  Support the PCC compiler.
  Style
  Use tailq from queue.h instead of rolling our down linked lists.
  Replace select with poll and nanosleep.
  Use posix_spawn instead of vfork to avoid signal races.
* Thu May 08 2008 varkoly@suse.de
- (bnc#266215) Wireless Access is not working on Vienna Airport
* Thu Apr 24 2008 dmueller@suse.de
- make dhcpcd-test executable
* Wed Apr 23 2008 varkoly@suse.de
- runtime servers will be saved in /var/run/ntp/ instead of
  /dev/shm/sysconfig
- add missing /usr/sbin/dhcpcd-test
* Fri Apr 18 2008 varkoly@suse.de
- Change to the code base of Roy Marples <roy@marples.name>
  The initial version is 3.1.9
  For differences please read /usr/share/doc/packages/dhcpcd/dhcpcd-1-vs-3
* Tue May 22 2007 schwab@suse.de
- Fix unaligned data.
* Fri May 11 2007 varkoly@suse.de
- make rpm build more verbose if ./config failed
* Wed Dec 20 2006 poeml@suse.de
- allow other programs to use the port which dhcpcd uses [#117090]
  dhcpcd-1.3.22pl4-reuseaddr.dif
* Tue Jan 31 2006 ak@suse.de
- fix unalignment messages on ia64 (#146764)
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Thu Sep 29 2005 dmueller@suse.de
- add norootforbuild
* Mon Sep 05 2005 poeml@suse.de
- fix parsing of resolv.conf file when no 'search' line is present,
  preventing garbage from ending up in the new resolv.conf [#96662]
* Thu Aug 04 2005 poeml@suse.de
- security fix: a malformed DHCP packet could make dhcpcd read
  beyond the end of a buffer and therefore possibly crash.
  [#94547] no CVE number.
- add support for DHCP Option 119 (rfc 3397) (patch from Debian,
  adapted for modify_resolvconf handling)
- Fix the value of the "Maximum message size" option. This value
  includes the IP and UDP headers, and it's minium value is
  therefore 576, according to RFC2131. (patch from Debian)
* Fri Jun 24 2005 poeml@suse.de
- build with -fPIE/-pie
- (hopefully) fix creation of debug package
- add %%clean section
* Thu Jun 16 2005 poeml@suse.de
- revert compiled in default path of the hook script to
  /sbin/dhcpcd.exe, update man page for this change and remove
  surplus snprintf() argument in dhcpconfig.c [#85849]
- fix usage info in dhcpcd-test
* Mon Mar 07 2005 poeml@suse.de
- fix uninitialized NewSearchlist variable. Binary garbage could
  have been passed to modify_resolvconf if a DHCP server was
  configured without domain option. Consequentially, do not call
  modify_resolvconf with -l if there's no domain name [#66869]
* Wed Sep 29 2004 poeml@suse.de
- netBIOSnodeType is a single byte option [#46395]
* Wed Sep 15 2004 schwab@suse.de
- Fix checksumming for big endian [#44670].
* Mon Sep 13 2004 poeml@suse.de
- make sure that dhcpcd has terminated after dhcpcd-test [#44557]
* Mon Sep 06 2004 poeml@suse.de
- add '-e $interface' to all calls of modify_resolvconf [#44706]
* Thu Aug 26 2004 lmuelle@suse.de
- Request netBIOSdgramDistServer, netBIOSnodeType, and netBIOSscope options
  and write it to /var/lib/dhcpcd/dhcpcd-*.info.
- Remove sohoServer option.
* Mon Mar 29 2004 poeml@suse.de
- fix path of xntpd's driftfile and logfile in the /etc/ntp.conf
  that is written [#37138]
* Thu Jan 15 2004 uli@suse.de
- removed fake LLC header patch (bug #33452)
* Mon Sep 08 2003 poeml@suse.de
- update README
- <feedback@suse.de> -> <http://www.suse.com/feedback>
* Fri Sep 05 2003 poeml@suse.de
- in the dhcpcd-test wrapper, do not run hook scripts by default
  (it can be called with -c /path/to/script to override the
  default, though) [#29945]
* Mon Aug 25 2003 poeml@suse.de
- rename the hook script from dhcpcd.exe to dhcpcd-hook, and fix
  all places of the man page mentioning it. The dhcpcd-hook script
  itself is part of the sysconfig package.
- minor updates to the dhcpcd.exe example and addition of a comment
  that there is now a more general framework for such hooks
* Sun Jul 27 2003 poeml@suse.de
- don't explicitely strip binaries since RPM handles it, and may
  keep the stripped information somewhere
* Mon Jun 30 2003 uli@suse.de
- add fake LLC header on S/390 to make DHCP work with OSA-Express
  in QDIO mode
* Wed Apr 02 2003 ro@suse.de
- fix sed call
* Thu Mar 13 2003 poeml@suse.de
- don't set the low timeout when in INIT state, and restore it as
  soon as we got an address. This partially fixes #25272 where the
  alarm clock was still set while doing stuff that is potentially
  time intensive (calling external scripts, resolving hostname)
* Thu Jan 02 2003 poeml@suse.de
- update to dhcpcd-1.3.22pl4, relevant changes:
  - set the netmask properly for static routes provided by the server
  - randomize XID better by including CLientHwAddr into the seed
  for srandom()
  - fix dhcpcd cache overriding command line options -I and -i
  - replace getuid() call with geteuid() in dhcpcd.c to enable
  setuid tools to launch dhcpcd.
  - fix a case of dhcpcd client crash because of some DHCP server
  sending no dhcpMessageType field in DHCP message.
  - all strings in *.info file are quoted now, and single quotes
  stripped from the strings
  - potential race condition between setting up the setjmp for
  dhcpReboot and the sigalarm handler eliminated
  - handle situations with DHCP server changing lease or T1,T2
  times from renewal to renewal.
- rename our -S switch to -K
- re-diff patches (much code has moved to dhcpconfig.c), and drop
  these patches that are included upstreams:
  no-second-discover.dif
  no-gateway.dif
  LOG_CONS.dif
  token-ring.dif
  noshellmeta.patch
* Thu Sep 26 2002 okir@suse.de
- properly quote string data in info file (sourced by dhcpcd.exe)
* Wed Sep 18 2002 ro@suse.de
- removed bogus self-provides
* Mon Aug 19 2002 poeml@suse.de
- add Token Ring support, using a very old GPL'ed patch by Olicom
  as a start
  ftp://ftp.olicom.dk/sw/releases/Unix-Driver/Linux/unsupported/DHCP/22/
- set the alarm clock more intelligently. Now dhcpcd, when in
  INIT-REBOOT state, should at any rate move to INIT if it did not
  get an address during RebootTimeOut. This should avoid dhcpcd
  quitting after RebootTimeOut in rare cases.
- increase default RebootTimeOut from 5 to 10 seconds, and set the
- look for a dhcpcd-*.exe script in
  /etc/sysconfig/network/scripts/, not in /sbin
- request netBIOSnameServer (WINS server) option and write it to
  /var/lib/dhcpcd/dhcpcd-*.info
- make it easy to build an unstripped debug binary
* Tue Apr 16 2002 poeml@suse.de
- the man page talked about 10 seconds as RebootTimeOut default,
  while it is actually 5 seconds
* Mon Apr 08 2002 ro@suse.de
- run autoreconf
* Mon Mar 04 2002 poeml@suse.de
- the default info text that modify_resolvconf writes has changed.
* Mon Feb 18 2002 poeml@suse.de
- don't log to the console when not in debug mode.
  (replaces the terminate_quietly diff)
- decrease RebootTimeOut to 5 seconds
* Fri Feb 15 2002 poeml@suse.de
- improve the test mode: the pid file goes to /var/run by default,
  but goes to the specified "data dir" (-L) so testing is possible
  while another dhcpcd is running
- don't restore resolv.conf when called with -R
* Fri Feb 15 2002 poeml@suse.de
- depending on the -t timeout option, dhcpcd will not make the
  transition from the INIT-REBOOT state (trying to reacquire a
  previous lease) to the INIT state (acquire a new lease), if it
  can't get the old lease before the timeout. Since even the
  default of 60 seconds seem much too long for this, I have added
  -z <reboot timeout> specifically for this state (default 10 s).
  This is good when there is no authoritative server to reply with
  DHCPNAK, and an old cache file is present. It works also in the
  rebinding state. So a large value for -t can still be used, to
  keep the daemon running.
* Sun Feb 10 2002 poeml@suse.de
- strip the DNS domain before setting the hostname. We don't want
  'hostname' to return the FQDN -- which can be and has to be the
  resolver's job.
- terminate without logging about it -- usually syslog is no longer
  running
- drop sysconfig.dhcp-dhcpcd (it's in the sysconfig package now)
- more-options.dif: request options in other DHCP messages, too
- fix pathnames to config files in modify_resolvconf message
- add -G option (prevents setting the default gateway), needed if
  multiple dhcpcd's are running
- don't depend on a second DHCPOFFER -- breaks with Lucent
  Technologies server
- set the *NIS* domainname if one was supplied
* Mon Feb 04 2002 poeml@suse.de
- update to dhcpcd-1.3.22pl1
  - ntp.conf and yp.conf is written by default now, unless -N and
    -Y are specified on the commandline
  - -T behaviour has changed, the cache will be written and dhcpcd
  forks into background
  - dhcpcd saves the hostname and domainname of the host and
  restores it upon exit
  - dhcpcd.exe script calling convention has changed. Now dhcpcd
  will pass the path to *.info file as first argument and
  "up/down/new" keyword as second argument, and optional -d as
  third one. -c can be used to specify an alternative script.
  - added workaround for starting multiple dhcpcd processes
  - nisDomainName is no longer used for resolv.conf
  - added support for virtual interfaces
  - added support for token ring (may work or not)
  - secs field is increased to 10 (needed for some NT servers)
  - dhcpcd sets umask to 022
  - dhcpcd tries to set optionally supplied static routes
  - possible loop in lease renewal code fixed
  - fixed setting wrong netmask in class A network
- drop obsolete dhcpcd-1.3.19pl8.dif
- fillup template into /etc/sysconfig/dhcp (which is shared with
  dhclient now)
- patch: use /var/run for pid file as before
- check if OldSearchList is valid (#11687)
- add new options to sysconfig.dhcp-dhcpcd (these are meant to be
  used by ISC dhclient with a wrapper as well)
- remove Conflicts: with ISC dhclient
* Tue Jan 29 2002 poeml@suse.de
- drop /etc/init.d/dhclient script (new script in sysconfig.rpm)
* Thu Dec 13 2001 ro@suse.de
- moved rc.config.d -> sysconfig
* Tue Sep 04 2001 poeml@suse.de
- fix a possible segfault when the DHCP server doesn't give a
  domain-name option (thanks to Nico Lumma who helped me to track
  this down)
- make sure that OldSearchList is initialized
* Tue Aug 28 2001 poeml@suse.de
- update to 1.3.20pl0 (the single change is the removement of 0x0
  from ClientID and ClassID options)
- use the modify_resolvconf tool for all resolv.conf modifications
- fix -S option to avoid double entries in the searchlist
- report to syslog only if running in debug mode (we would clobber
  the screen at boot time because syslogd is started later)
- add dhcpcd.rc.config variables for -I (client identifier) and -h
  (hostname option) options (some ISPs require these options;
  typically, they are needed with cable modems)
- also request the options sohoServer (option 200), lprServer and
  logServer (sohoServer is used to recognize a SuSE SOHO dhcp
  server) and write those data to /var/lib/dhcpcd/dhcpcd*info
- rc.dhclient:
  * decrease startproc timeout if we are not called at boot time
  * restart target: give modify_resolvconf some time to complete
- rename localstatedir from /var/state/dhcp to /var/lib/dhcpcd to
  comply with FHS 2.1 (now the path corrections are done with 'sed'
  instead of patching the sources)
- actually use the RPM_OPT_FLAGS
- rename README.SuSE to README.SuSE.dhcpcd and update it
* Fri May 11 2001 poeml@suse.de
- if resolv.conf does not exist, touch it; so that there is a file
  to back up and restore later and the temporary resolv.conf would
  not persist after stopping the client [#8078]
- use the modify_resolvconf tool to cleanup old backup files before
  starting the daemon, because it does it intelligently [#8077]
- don't send DHCPRELEASE by default when stopping (to avoid error
  messages when the interface has already disappeared [#8019])
* Sun Apr 15 2001 poeml@suse.de
- don't KeepSearchlist if there is no resolv.conf (fixes a bug
  where garbage was appended)
- set the default for KeepSearchlist to "no"
- start script:
   - get try-restart (meaning "restart when running") right
   - replace meaningless ${2+"$2"} with $2
   - fix probe section to take the correct pid file(s)
- update info header for resolv.conf acc. to guidelines
* Thu Apr 12 2001 poeml@suse.de
- fix start script [#6961] (-D and -H were mixed up)
* Mon Apr 09 2001 poeml@suse.de
- don't use of rc_status with -u (option was dropped)
- move rcdhclient link from /usr/sbin/ to /sbin, since the binary
  is also there
* Thu Apr 05 2001 poeml@suse.de
- update to 1.3.19pl9 (fixes a bug which resulted in 7-byte long
  MAC address with 0x0 at the end)
- fix Version tag
* Wed Mar 28 2001 poeml@suse.de
- update to 1.3.19pl8
- add -S switch to keep searchlist when resolv.conf is replaced
- change backup name of resolv.conf and write info header to the
  new one
- drop res_init() patch because it is included in pl8
- fix missing includes
- rework init script:
  * adhere to LSB, use /etc/rc.status
  * move variables to /etc/rc.config.d/
  * make more stuff configurable
- bzipped sources
* Wed Jan 24 2001 poeml@suse.de
- update to 1.3.19pl6
- dhcpcd-<interface>.exe scripts, to be called by dhcpcd, are
  expected in /usr/sbin now, no longer in /var/state
- added a README.SuSE explaining the SuSE changes to the package
- the configuration has improved, so some patches are no longer
  necessary
* Mon Jan 15 2001 poeml@suse.de
- added patch to write resolv.conf and call res_init() before
  resolving the hostname (fixes bug #4526)
- added comments on how to build for different runlevel scheme in 7.0 or
  earlier
- insert missing "" in Nov 17 patch for configure script
* Thu Jan 11 2001 poeml@suse.de
- fix path in comment (/sbin/init.d -> /etc/init.d)
* Tue Nov 28 2000 poeml@suse.de
- moved init script to /etc/init.d
- create links via insserv
- extracted source files from the patch to separate files
- cleaned up spec file
* Fri Nov 17 2000 poeml@suse.de
- fixed spec file to remove stale config.cache
- fixed configure script to make testing for 2.0.x kernel work
* Fri Nov 17 2000 kukuk@suse.de
- Fix Requires
* Thu Oct 19 2000 grimmer@suse.de
- Update to 1.3.19pl2 (Bugfix: don't use nisDomainName in
  /etc/resolv.conf)
* Mon Aug 07 2000 grimmer@suse.de
- Update to 1.3.19p1 (bugfix for dhcpStop function, see ChangeLog)
* Mon Aug 07 2000 grimmer@suse.de
- Update to 1.3.19p0 (Andreas Schwab's IA64 patch now officially
  included, uncommented ioctl call in dhcpStop to prevent interface
  from having an invalid IP address during DHCP negotiation,
  dhcpcd is now libc5 and glibc compatible)
- added sample script dhcpcd-eth0.exe.SuSE from Pieter Hollants
  <Pieter.Hollants@suse.de>
- Reworked rc.config comments
* Thu Jul 13 2000 zoz@suse.de
- changed test for availability of device: now using ifconfig, so
  automatically loading of modules will be triggered (Bug 3415)
* Tue Jul 11 2000 zoz@suse.de
- reworked /sbin/init.d/dhclient once again due to problems with
  PCMCIA devices.
- added DHCLIENT_SET_HOSTNAME (default =no) to rc.config and
  /sbin/init.d/dhclient. (same as in package dhclient)
* Thu Jul 06 2000 zoz@suse.de
- removed a lost and lonly "fi" from rcdhclient (Bug 3208)
* Wed Jul 05 2000 zoz@suse.de
- changed /sbin/init.d/dhclient:
  - It now starts without "DHCLIENT".
  Just setting IFCONFIG_x with NETCONFIG contains _x is enough.
  - It does not stop the demon, if it was set up by pcmcia-scripts
  but writes a message what to do then.
- changed rc.config.dhclient: removed "DHCLIENT", but left the
  comment.
* Fri Jun 16 2000 grimmer@suse.de
- Update to dhcpcd-1.3.18-pl8 (new -T flag to go through normal
  DHCP negotiation sequence without configuring the interface or
  otherwise change anything on the system, fix possible problem
  in retransmitting DHCP requests, and make dhcpcd adapt to
  possible change in DHCP server address in the middle of a
  client's lease, new -C option to perform checksum on received
  packets, now set dhcpcd's process umask to 022 before creating
  /etc/resolv.confi, new -n flag to force currently running
  dhcpcd to try to renew the lease)
- now uses GNU autoconf and automake
- added Red Hat's Token Ring patch and submitted it to author
- added BuildRoot and RPM macros
- added /sbin/icmprequest to file list
- added more docu to file list
* Tue Mar 28 2000 grimmer@suse.de
- Update to dhcpcd-1.3.18-pl5 (reverse lookup patch is now
  officially included)
- removed our (now obsolete) patch
* Mon Mar 27 2000 grimmer@suse.de
- Update to dhcpcd-1.3.18-pl4 (minor fixes)
* Mon Mar 13 2000 grimmer@suse.de
- reverted init script to original behaviour since automatic
  setting of host name is not always desirable (e.g. X11)
* Sun Mar 12 2000 bk@suse.de
- added reverse lookup for sethostname; if -H option is given
  and dhcpcd didn't get a hostname from the dhcp server.
- Olaf added silent startup of dhcpcd.
* Sun Mar 12 2000 grimmer@suse.de
- added Option -D -H (set domain- and hostname) to init script
* Fri Feb 18 2000 grimmer@suse.de
- added Option -d (for logging via syslog) to init script
* Thu Jan 27 2000 grimmer@suse.de
- initial version (1.3.18-pl3)
- changed man path to /usr/share/man
- adjusted path for leases from /etc/dhcpc to /var/state/dhcp
- created init script (compatible with dhclient) and variables
  for /etc/rc.config
